"use strict";

module.exports = function( grunt ) {
	var path = require( "path" );
	grunt.initConfig({
		servers: {
			wildfly: {
				options: {
					directory: "test/integration/deployment/target",
					preset: "wildfly-8.1.0.Final"
				},
				files: [{
					expand: true,
					cwd: "test/integration/deployment/qunit/",
					src: [ "**/*" ]
				}]
			}
		},
		jshint: {
			files: [
				"Gruntfile.js",
				"tasks/**/*.js"
			],
			options: {
				jshintrc: true
			}
		},
		jscs: {
			files: [
				"Gruntfile.js",
				"tasks/**/*.js"
			]
		},
		nodeunit: {
			all: [ "test/unit/**/*_test.js" ]
		},
		qunit: {
			wildfly: {
				options: {
					urls: [
						"http://localhost:8080/<%= servers.wildfly.options.preset %>/index.html"
					]
				}
			}
		}
	});
	
	// Load grunt tasks from NPM packages
	require( "load-grunt-tasks" )( grunt );
	
	// Load local tasks
	grunt.loadTasks( "tasks" );
	
	// Main aliases
	grunt.registerTask( "integration", ["servers:wildfly", "qunit", "servers:wildfly:kill"] );
	grunt.registerTask( "unit", ["validate", "nodeunit"] );
	grunt.registerTask( "validate", ["jshint", "jscs"] );
	
	// Special aliases
	grunt.registerTask( "default", ["validate", "unit", "integration"] );
	grunt.registerTask( "travis", ["validate", "unit", "integration"] );
};
