module.exports = function() {
	var configs = require( "./configs" );
	var grunt = require( "grunt" );
	var Promise = require( "promise" );
	var registration = require( "./registration" );
	return (function( options ) {
		var taskTarget = this.target;
		var reg = registration( this.target );
		var serverConfig = configs( taskTarget, options );
		return new Promise(function( resolve, reject ) {
			var warDelete = function( deleted ) {
				var warPath = serverConfig.getWARPath();
				if ( grunt.file.exists( warPath ) ) {
					try {
						grunt.file.delete( warPath );
					} catch ( e ) {
						// Windows throws ENOTEMPTY if task is executed too fast
						if ( e.code === "ENOTEMPTY" ) {
							setTimeout( 100, warDelete );
							return;
						}
					}
				}
				deleted();
			};
			var processKill = function( killed ) {
				reg.kill( killed );
			};
			
			new Promise( processKill )
				.then(function() {
					return new Promise( warDelete );
				})
				.then(function() {
					serverConfig.afterCleanup();
					resolve();
				})
				.catch( reject );
		});
	}).bind( this );
};
