module.exports = function() {
	var grunt = require( "grunt" );
	var Promise = require( "promise" );
	var configs = require( "./configs" );
	return (function( options ) {
		var files = this.files;
		var serverConfig = configs( this.target, options );
		var serverHome = serverConfig.getServerHome();
		return new Promise(function( resolve, reject ) {
			files.forEach(function( file ) {
				var targetDir = serverConfig.getWARPath() + "/" + file.dest;
				var src = file.src[ 0 ];
				
				grunt.log.debug( "Reading src: " + src );
				grunt.log.debug( "Writing to dest: " + targetDir );
				
				if ( grunt.file.isDir( src ) ) {
					return;
				}
				
				grunt.file.copy( src, targetDir );
			});
			resolve();
		});
	}).bind( this );
};
