module.exports = function() {
	var configs = require( "./configs" );
	var File  = require( "./filewrapper" );
	var fs = require( "fs" );
	var grunt = require( "grunt" );
	var Promise = require( "promise" );
	var unzip = require( "unzip" );
	return (function( downloadedFilePath, options ) {
		var serverConfig = configs( this.target, options );
		var file = new File( downloadedFilePath );
		var extractedDir = serverConfig.getExtractedDir();
		var serverHome = serverConfig.getServerHome();
		return new Promise(function( resolve, reject ) {
			if ( grunt.file.exists( serverHome ) ) {
				grunt.log.writeln( "Directory \"" + serverHome + "\" already exists." );
				resolve();
				return;
			}
			if ( !file.isZipped() ) {
				reject( new Error( "File is not zipped" ) );
				return;
			}
			grunt.log.writeln( "Extracting to \"" + extractedDir + "\"" );
			fs
				.createReadStream( downloadedFilePath )
				.pipe( unzip.Extract({ path: extractedDir }) )
				.on( "close", resolve );
		});
	}).bind( this );
};
