var instances = {};
module.exports = function( taskTarget ) {
	var grunt = require( "grunt" );
	var kill = require( "tree-kill" );
	return {
		register: function( serverProcess, listener ) {
			instances[ taskTarget ] = {
				process: serverProcess
			};
			serverProcess.stdout.on( "data", listener );
		},
		kill: function( resolve ) {
			var instance = instances[ taskTarget ];
			
			grunt.log.debug( "Killing server related to target: " + taskTarget );
			
			if ( !instance ) {
				grunt.log.debug( "Server not online for cleanup of target: " + taskTarget );
				resolve();
				return;
			}
			
			instance.process.on( "exit", function() {
				delete instances[ taskTarget ];
				grunt.log.debug( "Killed server related to target: " + taskTarget );
				resolve();
			});
			
			grunt.log.debug( "Killing... " + instance.process.pid );
			
			kill( instance.process.pid );
		}
	};
};
